<template>
  <div>
    <AdressItem
      :address="addressList.from"
      @update="addressToEdit = 'from'"
      @search="searchAddress(addressList.from)"
    ></AdressItem>
    <br />
    <AdressItem
      :address="addressList.to"
      @update="addressToEdit = 'to'"
      @search="searchAddress(addressList.to)"
    ></AdressItem>
    <br />

    <AddressForm
      v-if="addressToEdit"
      :label="addressList[addressToEdit].label"
      v-model:address="addressList[addressToEdit]"
      v-model:road="addressList[addressToEdit].road"
      v-model:zipCode="addressList[addressToEdit].zipCode"
      v-model:city="addressList[addressToEdit].city"
      v-model:complement="addressList[addressToEdit].complement"
      v-model:country="addressList[addressToEdit].country"
      v-model:state="addressList[addressToEdit].state"
      @close="addressToEdit = null"
    ></AddressForm>

    Number of results : {{ coordinatesLength }} {{ coordinatesLengthFromStore }}

    <AddressResult
      v-if="!searchStore.loading && searchStore.coordinates.length > 0"
      :coordinates="searchStore.coordinates"
      @select="searchStore.currentCoordinate = $event"
    ></AddressResult>

    <div
      v-else-if="!searchStore.loading && searchStore.coordinates.length === 0"
    >
      Aucun résultat de recherche...
    </div>
    <div v-else>Loading...</div>

    <CarteLeaflet
      :coordinates="searchStore.coordinates"
      :currentCoordinate="searchStore.currentCoordinate"
      :jsonData="gardens"
      v-model="bbox"
    />

    <button @click="searchGarden">Charger espaces verts</button>
  </div>
</template>

<script lang="js">
import AdressItem from '../components/AddressItem.vue'
import AddressForm from '../components/AddressForm.vue';
import AddressResult from '../components/AddressResult.vue';
import CarteLeaflet from '../components/CarteLeaflet.vue';
import { getOverpassData } from '../services/overpass'
import { useSearchStore }from '../stores/search'

const searchStore = useSearchStore()

export default {
  components: {
    AdressItem,
    AddressForm,
    AddressResult,
    CarteLeaflet
  },
  data() {
    return {
      searchStore: searchStore.state,
      addressList: {
        from: {
          label: 'Origine',
          road: "11 rue du Marchix",
          zipCode: "44000",
          city: "Nantes",
          complement: "Makina Corpus",
          country: "Pays de la Loire" // ici, nous ne déclarons pas la variable "state"
        },
        to: {
          label: 'Destination',
          road: "Château des ducs de Bretagne",
          zipCode: "44000",
          city: "Nantes",
          state: "France"
        },
      },
      addressToEdit: null,
      currentCoordinate: null,
      gardens: [],
      loadingNominatim: false,
      bbox: null
    };
  },
  computed: {
    coordinatesLength() { return  this.searchStore.coordinates.length },
    coordinatesLengthFromStore: () => searchStore.coordinatesLength,
  },
  methods: {
    searchAddress: searchStore.searchAddress,
    async searchGarden() {
      const data = await getOverpassData(this.bbox)
      this.gardens = data
    }
  },
  created() {
    if (this.$route.params.address) {
      this.from = JSON.parse(this.$route.params.address);
    }
    if (this.from) {
      this.searchAddress(this.from);
    }
  },

}
</script>
